$(document).ready(inicioVua);

(function ($) {
    $.fn.hasScrollBar = function () {
        return this.get(0).scrollHeight > this.height();
    }
})(jQuery);

var article = document.getElementsByClassName("vua__tema");
var barraNavegacion = document.getElementsByClassName("vuaMenu js-vuaMenu");
// function by scorm init
var scorm_finished = false;
var location_theme = 1;
var audioFinal = new Audio('audio/drager.mp3');

window.onunload = scormEnd;
window.onbeforeunload = scormEnd;

function stopFinalAudio() {
    if (!audioFinal.paused) {
        audioFinal.pause();
        audioFinal.currentTime = 0;
    }
}

function scormEnd() {
    // si ya esta completado no accede

    // si esta en 100 no vuelve a marcar
    if (SCORM.GetScoreRaw() && Number(SCORM.GetScoreRaw()) >= 100) {
        SCORMMarkerCompleted(true);
    } else {
        if (scorm_finished) {
            SCORMMarkerCompleted(true);
            SCORM.SetScoreRaw(100);
        }
        SCORMSetIfLocationMax(location_theme);
    }
    SCORMFinalizate();

};

function restoreLocation(location_scorm) {
    if (!location_scorm) {
        return;
    }
    for (let i = 0; i <= location_scorm; i++) {
        activeVuaMenuNext(i);
    }
    $("[data-vuamenu=" + location_scorm + "]").click();
}
////// fin scorm init
function progreso() {
    var winScroll = this.scrollTop || this.scrollTop;
    var height = this.scrollHeight - this.clientHeight;
    var scrolled = (winScroll / height) * 100;
    document.getElementById("pBar").style.width = scrolled + "%";
}

//Funcion encargada de mostrarme el tema activo en la barra de navegacion
function progresoNav() {
    if ($('.js-vuaMenu').hasScrollBar() == true) {
        var temaActivo = $('.vuaMenu__btn--activo');
        var numeroTemaActivo = temaActivo.attr('data-vuamenu');
        var limite = numeroTemaActivo * 100; // 100 es el alto de cada item del menu
        var height = $('.js-vuaMenu').height();

        if (limite > (height - 30)) {
            // var top = 50 * numeroTemaActivo; //estaba en 60 * index
            let top = positionScrollItem() - ($(".logo__container").outerWidth())
            $('.js-vuaMenu').stop().animate({
                scrollTop: top
            }, 500);
        }
    }
}
// retorna la posicion de scroll para el menu del vua
function positionScrollItem() {
    let data_vuamenu = parseInt($(".vuaMenu__btn--activo").attr('data-vuamenu'));
    let items = $(".vuaMenu__btn")
    let position = 0;

    for (let i = 0; i < items.length; i++) {

        vuamenu = parseInt(items[i].getAttribute("data-vuamenu"));
        position += $(items[i]).parent().height();
        if (vuamenu >= data_vuamenu) {
            // console.log("Ultimo data-vuemenu", vuamenu);
            break;
        }

    }

    return position;
}

function resetScroll(id) {

    // Se reinicia la barra de progreso
    var elem = document.getElementById('vuaMenu-tema' + id);

    elem.scrollTop = 0;

    setScrollAnimations(elem)

    if (elem.scrollHeight == elem.clientHeight) {
        document.getElementById("pBar").style.width = 100 + "%";
    } else {
        document.getElementById("pBar").style.width = 0 + "%";
    }

    // Se agrega el atributo autoplay, se pausa y se reinicia el audio

    reiniciarAudio();
    stopVideoYoutube();


    var tema = $("#vuaMenu-tema" + id + " audio");

    try {
        tema[0].play();
    } catch (error) {
        console.log(error);
    }


}

function reiniciarAudio() {
    var temaClass = $(".vua__tema audio");
    for (let index = 0; index < temaClass.length; index++) {
        const audio = temaClass[index];

        audio.pause();
        audio.currentTime = 0;
    }
}



//Función que tiene la responsabilidad de iniciar el VUA
function inicioVua() {

    SCORMInitializate();

    accordionOnClicl();
    showNowAccordion($(".vuaMenu__btn--activo"));

    // Funcion que asigna el delay de la animación
    var delay = $("[data-settings*='animation_delay']");

    delay.each(function () {
        var dataSettings = $(this).attr("data-settings");
        var separado = dataSettings.split(":");
        var separado2 = separado.reverse()[0];
        var valorDelay = separado2.split("}");

        $(this).attr('style', 'animation-delay: ' + valorDelay[0] + 'ms');
    })

    // When the user scrolls the page, execute myFunction 
    for (let i = 0; i < article.length; i++) {
        article[i].addEventListener("scroll", progreso);
    }

    cerrarPrecarga();

    $('.expandir__btn').off('click');

    $('.js-vua__btnGlosario').off('click');
    $('.js-vua__btnGlosario').on('click', ventanaPullGlosario);
    $('.ventanaPullGlosario__tituloCerrar').off('click');
    $('.ventanaPullGlosario__tituloCerrar').on('click', ventanaPullGlosarioCerrar);

    $('.js-vua__btnBibliografia').off('click');
    $('.js-vua__btnBibliografia').on('click', ventanaPullBibliografia);
    $('.ventanaPullBibliografia__tituloCerrar').off('click');
    $('.ventanaPullBibliografia__tituloCerrar').on('click', ventanaPullBibliografiaCerrar);

    $('[data-vuaMenu]').off('click');
    $('[data-vuaMenu]').on('click', menuVua);

    $('[data-redi]').off('click');
    $('[data-redi]').on('click', lanzadorRedi);

    $('.js-vua__btnCerrarNav').off('click');
    $('.js-vua__btnCerrarNav').on('click', navVua);

    $('.js-vua__btnCerrar').off('click')
    $('.js-vua__btnCerrar').on('click', cerrarVUA);

    $('.js-rediLanzador2__boton').on('click', navegacionExplora);

    $(document).keydown(function (e) {
        if (e.keyCode == 27) {
            if ($('.redi--activo').length == 1) {
                cerrarRedi();
            } else {
                cerrarVUA();
            }
        }
        //flechas
        if (e.keyCode == 37) {
            //call function prev
            anterior();
        }
        if (e.keyCode == 39) {
            //call function netx
            siguiente();
        }
    });

    altoEncabezadoVua();

    $(window).on('resize', altoEncabezadoVua);

    activaNavegacion();

    window.addEventListener('message', function (event) {
        if (event.data.hasOwnProperty("cerrarRedi")) {
            this.console.log("Mensaje recibido");
            $('.redi--activo').addClass('redi--inactivo');
            $('.redi').removeClass('redi--activo');
        }

    });

    // $(".itemMenu").each(function (i, elem) {
    //     if (i == 0) {
    //         console.log("Entró")
    //         elem[i].addClass('itemMenu--activo');
    //     }

    // });

    disableVuaMenu(); // desactivar menu y solo deja un item activo
    SCORMRestoreLocation(restoreLocation); // restauracion scorm
    agregarDataTitulos(); // Tabla responsive
    removeAnimatedClass();
}

function navVua() {

    if ($('.js-vua__nav').hasClass('vua__nav--abierto')) {
        $('.js-vua__nav').removeClass('vua__nav--abierto');
        $('.js-vua__btnCerrarNav').removeClass('vua__btnCerrarNav--abierto');
    } else {
        $('.js-vua__nav').addClass('vua__nav--abierto');
        $('.js-vua__btnCerrarNav').addClass('vua__btnCerrarNav--abierto');
    }


}

function activaNavegacion() {
    var temaActivo;
    var numeroTemaActivo;
    var ultimoTema;

    temaActivo = $('.vuaMenu__btn--activo');
    numeroTemaActivo = temaActivo.attr('data-vuamenu');
    ultimoTema = getUltimoTema();
    console.log("numero: ", numeroTemaActivo);
    console.log("ultimo: ", ultimoTema);

    $(".navegacion").hide();

    if (numeroTemaActivo > 1) {
        console.log('activar boton anterior');

        $('.navegacion__contenedorBtn--anterior').removeClass("hidden");
        $('.navegacion__contenedorBtn--anterior').addClass("visible");
        $('.navegacion__contenedorBtn--anterior').off('click');
        $('.navegacion__contenedorBtn--anterior').on('click', anterior);
    } else {
        $('.navegacion__contenedorBtn--anterior').removeClass("visible");
        $('.navegacion__contenedorBtn--anterior').addClass("hidden");
        $('.navegacion__contenedorBtn--anterior').off('click');
        console.log('desactiva boton anterior');

    }

    if (numeroTemaActivo < ultimoTema) {
        console.log('activar boton siguiente');

        $('.navegacion__contenedorBtn--siguiente').removeClass("hidden");
        $('.navegacion__contenedorBtn--siguiente').addClass("visible");
        $('.navegacion__contenedorBtn--siguiente').off('click');
        $('.navegacion__contenedorBtn--siguiente').on('click', siguiente);
    } else {
        $('.navegacion__contenedorBtn--siguiente').removeClass("visible");
        $('.navegacion__contenedorBtn--siguiente').addClass("hidden");
        $('.navegacion__contenedorBtn--siguiente').off('click');
        console.log('desactiva boton siguiente');
    }

    $('.navegacion__contenedorBtn--siguiente .navegacion__btn--final').html('Finalizar');

    setTimeout(() => {
        $(".navegacion").show();
    }, 500);

}


//funcion que tiene la responsabilidad de reiniciar el video cuando abren el explora
function navegacionExplora() {
    reiniciarAudio();
}

//funcion que tiene la responsabilidad de cargar el item anterior
function anterior() {
    stopFinalAudio();
    console.log('anterior')
    var temaActivo, temaAnterior;
    temaActivo = $('.vuaMenu__btn--activo');
    var numeroTemaActivo = temaActivo.attr('data-vuaMenu');
    console.log("numero activo: ", numeroTemaActivo);

    stopFinalAudio();

    if (numeroTemaActivo > 1) {
        numeroTemaActivo = parseInt(numeroTemaActivo) - 1;
        $("[data-vuaMenu=" + numeroTemaActivo + "]").click();
    } else {
        console.log("es el primer tema");
    }
}

//funcion que tiene la responsabilidad de cargar el item siguiente
function siguiente() {
    console.log('siguiente');
    var temaActivo, numeroTemaActivo, ultimoTema;
    temaActivo = $('.vuaMenu__btn--activo');
    numeroTemaActivo = temaActivo.attr('data-vuaMenu');
    ultimoTema = getUltimoTema();

    console.log("ultimo", ultimoTema);
    console.log("tema activo", numeroTemaActivo);

    setTimeout(() => {
        if (numeroTemaActivo == ultimoTema) audioFinal.play();
    }, 1000);

    if (numeroTemaActivo < ultimoTema) {
        numeroTemaActivo = parseInt(numeroTemaActivo) + 1;
        activeVuaMenuNext(numeroTemaActivo);
        $("[data-vuaMenu=" + numeroTemaActivo + "]").click();
    } else {
        console.log("es el ultimo tema");
    }
}


function altoEncabezadoVua() {
    var altoEncabezado = $('.js-vua__encabezado').height();
    document.querySelector('.vua').style.setProperty('--encabezado__alto', altoEncabezado + 'px');
}


function menuVua() {

    var dataVuaMenu = $(this).attr('data-vuaMenu');

    if (dataVuaMenu < 18) stopFinalAudio();

    console.log("tema ", dataVuaMenu);
    setTimeout(() => {
        resetScroll(dataVuaMenu);
    }, 300);

    $('[data-vuaMenu]').parent().removeClass('itemMenu--activo');
    $('.itemMenu').removeClass('itemMenu--activo');


    $('[data-vuaMenu]').parent().parent().parent().removeClass('itemMenu--activo');
    $('[data-vuaMenu="' + dataVuaMenu + '"]').parent().parent().parent().addClass('itemMenu--activo');

    $('[data-vuaMenu]').removeClass('vuaMenu__btn--activo');

    // $('[data-vuaMenu="' + dataVuaMenu + '"]').parent().addClass('itemMenu--activo');
    $('[data-vuaMenu="' + dataVuaMenu + '"]').addClass('vuaMenu__btn--activo');

    $('.vuaMenu__contenido').removeClass('vuaMenu__contenido--inactivo');
    $('.vuaMenu__contenido--activo').addClass('vuaMenu__contenido--inactivo');

    setTimeout(() => {
        $('.vuaMenu__contenido').removeClass('vuaMenu__contenido--activo');
        $('[data-vuaContenido ="' + dataVuaMenu + '"]').addClass('vuaMenu__contenido--activo');
    }, 200);

    $('.js-vuaCortinilla').removeClass('vuaCortinilla--activa');
    setTimeout(() => {
        $('.js-vuaCortinilla').addClass('vuaCortinilla--activa');
    }, 16);

    $('.js-vua__nav').removeClass('vua__nav--abierto');
    $('.js-vua__btnCerrarNav').removeClass('vua__btnCerrarNav--abierto');

    activaNavegacion();
    progresoNav();
    showNowAccordion($('.vuaMenu__btn--activo'));
}

function lanzadorRedi() {
    var dataRedi = $(this).attr('data-redi');
    $('.redi').removeClass('redi--inactivo');
    $('.redi').removeClass('redi--activo');
    $('#redi' + dataRedi).addClass('redi--activo');
    //se pausa los videos cuando se abre el REDI
    reiniciarAudio();
    stopVideoYoutube();
}

//funcion responsable de enviar el mensaje al padre para que cierre el backdrop
function cerrarVUA() {
    console.log('Mensaje cerrarVUA enviado');
    var data = {
        'close': 'cerrar',
    };
    window.top.postMessage(data, '*');

    reiniciarAudio();
}


//funcion responsable de enviar el mensaje al padre para que cerrar la precarga
function cerrarPrecarga() {
    console.log('Cerrando Precarga');
    var data = {
        'cerrarPrecarga': 'cerrar',
    };
    window.top.postMessage(data, '*');
}


//Glosario y Bibliografía

function ventanaPullGlosario() {
    if ($('.ventanaPullGlosario').hasClass('ventanaPullGlosario--cerrada')) {
        $('.ventanaPullGlosario').removeClass("ventanaPullGlosario--cerrada");
        $('.ventanaPullGlosario').addClass('ventanaPullGlosario--abierta');
    } else {
        $('.ventanaPullGlosario').removeClass("ventanaPullGlosario--cerrada");
        $('.ventanaPullGlosario').addClass('ventanaPullGlosario--abierta');
    }
}

function ventanaPullGlosarioCerrar() {
    $('.ventanaPullGlosario').removeClass("ventanaPullGlosario--abierta");
    $('.ventanaPullGlosario').addClass('ventanaPullGlosario--cerrada');
}

function ventanaPullBibliografia() {
    if ($('.ventanaPullBibliografia').hasClass('ventanaPullBibliografia--cerrada')) {
        $('.ventanaPullBibliografia').removeClass("ventanaPullBibliografia--cerrada");
        $('.ventanaPullBibliografia').addClass('ventanaPullBibliografia--abierta');
    } else {
        $('.ventanaPullBibliografia').removeClass("ventanaPullBibliografia--cerrada");
        $('.ventanaPullBibliografia').addClass('ventanaPullBibliografia--abierta');
    }
}

function ventanaPullBibliografiaCerrar() {
    $('.ventanaPullBibliografia').removeClass("ventanaPullBibliografia--abierta");
    $('.ventanaPullBibliografia').addClass('ventanaPullBibliografia--cerrada');
}


function getUltimoTema() {
    var ultimo = 0;
    $("[data-vuaMenu]").each(function (index) {

        if (parseInt($(this).attr("data-vuaMenu")) > ultimo) {
            ultimo = parseInt($(this).attr("data-vuaMenu"));
        }
    });

    return ultimo;
}

//function que tiene la responsabilidad de detener los videos de youtube
function stopVideoYoutube() {
    //recorro todos los iframe de youtube y envio la señal de pausa
    // los videos deben tener los parametros extra: &enablejsapi=1&version=3&playerapiid=ytplayer
    try {
        $("iframe").each(function (index) {
            //console.log( index + ": " + $( this ).text() );
            $(this).attr('src', $(this).attr('src'));
            $("iframe")[index].contentWindow.postMessage('{"event":"command","func":"' + 'stopVideo' + '","args":""}', '*');
        });
    } catch (e) {
        console.log(e);
    }
}

function disableVuaMenu() {
    // TODO: comentar esta linea de abajo si se desea almacenar temporalmente donde el usuario desbloqueo
    localStorage.clear();
    var item = localStorage.getItem("num_theme_active") || 1;

    for (let i = 1; i <= item; i++) {
        $(`.js-vuaMenu [data-vuaMenu=${i}]`).removeClass("disabled");
    }

    $(".js-vuaMenu .disabled").off("click");
}

function activeVuaMenuNext(i) {
    let item = localStorage.getItem("num_theme_active");

    if (i > item) {
        localStorage.setItem("num_theme_active", i);
    }

    setTimeout(() => {
        $(`.js-vuaMenu [data-vuaMenu=${i}]`).removeClass("disabled");
    }, 1000);

    $(`.js-vuaMenu [data-vuaMenu=${i}]`).off('click', menuVua);
    $(`.js-vuaMenu [data-vuaMenu=${i}]`).on('click', menuVua);
}

//Accordion

function accordionOnClicl() {
    $('[data-ed-accodion]').click(accordion);
}

function accordion() {
    var edAccordion = $(this).attr('data-ed-accodion');

    if ($('#ed-accodion-' + edAccordion).hasClass('ed-accodion-activo')) {
        $('#ed-accodion-' + edAccordion).slideUp(350);
        $('#ed-accodion-' + edAccordion).removeClass('ed-accodion-activo');
        $(this).removeClass("accordion__btn--active");
    } else {
        downAllAccordion();
        $('#ed-accodion-' + edAccordion).slideDown(350);
        $('#ed-accodion-' + edAccordion).addClass('ed-accodion-activo');
        $('[data-ed-accodion]').removeClass("accordion__btn--active");
        $(this).addClass("accordion__btn--active");
    }
}

function downAllAccordion() {
    $(".ed-accodion").removeClass("ed-accodion-activo");
    $(".ed-accodion").slideUp(350);
}

function showNowAccordion(item) {

    console.log("click");
    acordionItem = item.parent().parent() // padre 1 'li' padre 2 'ul acordion'

    if (!acordionItem.hasClass('ed-accodion-activo')) {
        downAllAccordion();
    }

    if (!acordionItem.hasClass('ed-accodion-activo')) {
        acordionItem.slideDown(350);
        acordionItem.addClass('ed-accodion-activo');
    }
}

//Función que tiene la responsabilidad de poner los titulos a cada uno de los mundos
function agregarDataTitulos() {
    $('.tablaMovil').each(function () {
        $(this).find('th').each(function (index) {
            var titulo = $(this).text();
            var i = parseInt(index) + 1;
            $(this).parent().parent().parent().find("td:nth-of-type(" + i + ")").attr('data-titletable', titulo);
        });
    });
}